package cours01;

public class Permutations {

	public static void main(String[] args) {

		String villes[] = { "Lorient", "Nice", "Perpignan", "Arras", "Montauban", "Metz", "Ceyssat", "Poitiers",
				"Arcachon", "Alfortville" };
		int distances[][] = { { 0, 1113, 863, 590, 632, 793, 581, 335, 492, 492 },
				{ 1113, 0, 471, 968, 561, 799, 534, 778, 795, 826 }, { 863, 471, 0, 970, 231, 869, 424, 562, 451, 796 },
				{ 590, 968, 970, 0, 784, 308, 557, 487, 755, 183 }, { 632, 561, 231, 784, 0, 778, 278, 339, 236, 604 },
				{ 793, 799, 869, 308, 778, 0, 502, 569, 824, 302 }, { 581, 534, 424, 557, 278, 502, 0, 246, 394, 377 },
				{ 335, 778, 562, 487, 339, 569, 246, 0, 268, 319 }, { 492, 795, 451, 755, 236, 824, 394, 268, 0, 584 },
				{ 492, 826, 796, 183, 604, 302, 377, 319, 584, 0 } };
		// représentation d'une permutation
		int n = 10;
		int[] tabInd = new int[n];
		for (int i = 0; i < n; i++)
			tabInd[i] = i;

		boolean fin;
		do {
			
			int dist = distVoyage(distances, tabInd);
			
			for (int i = 0; i < n; i++)
				System.out.print(tabInd[i] + " ");
			System.out.println(dist);

			fin = suivantPermutation(tabInd);
			
		}

		while (fin == false);
	}
	
	
	// calcul de la distance parcourue pendant le voyages
	public static int distVoyage(int[][] distances, int[] tabInd) {
		
		//votre code
	}

	// Algorithme itératif de Narayana P. (1356)
	public static boolean suivantPermutation(int[] tabInd) {
		int n = tabInd.length;
		int i;
		// étape 1
		for (i = n - 2; i >= 0; i--) {
			if (tabInd[i] < tabInd[i + 1])
				break;
		}
		if (i == -1)
			return true;
		// étape 2
		int j;
		for (j = n - 1; j > i; j--) {
			if (tabInd[i] < tabInd[j])
				break;
		}
		// étape 3
		int tmp = tabInd[i];
		tabInd[i] = tabInd[j];
		tabInd[j] = tmp;
		// étape 4
		for (int k = i + 1; k <= (n + i) / 2; k++) {
			tmp = tabInd[k];
			tabInd[k] = tabInd[n + i - k];
			tabInd[n + i - k] = tmp;
		}

		return false;
	}

}
